
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class App_settingsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const app_settings = await db.app_settings.create(
            {
                id: data.id || undefined,
        
        accounting_coding_mode: data.accounting_coding_mode
        ||
        null
            ,
            
        analytic_levels_count: data.analytic_levels_count
        ||
        null
            ,
            
        enable_branching: data.enable_branching
        ||
        false
        
            ,
            
        enable_multi_currency: data.enable_multi_currency
        ||
        false
        
            ,
            
        enable_document_workflow: data.enable_document_workflow
        ||
        false
        
            ,
            
        enable_network_dongle: data.enable_network_dongle
        ||
        false
        
            ,
            
        default_currency_code: data.default_currency_code
        ||
        null
            ,
            
        numbering_profile_code: data.numbering_profile_code
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await app_settings.setBusiness( data.business || null, {
            transaction,
        });
        

        

        

        return app_settings;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const app_settingsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                accounting_coding_mode: item.accounting_coding_mode
            ||
            null
            ,
            
                analytic_levels_count: item.analytic_levels_count
            ||
            null
            ,
            
                enable_branching: item.enable_branching
            ||
            false
        
            ,
            
                enable_multi_currency: item.enable_multi_currency
            ||
            false
        
            ,
            
                enable_document_workflow: item.enable_document_workflow
            ||
            false
        
            ,
            
                enable_network_dongle: item.enable_network_dongle
            ||
            false
        
            ,
            
                default_currency_code: item.default_currency_code
            ||
            null
            ,
            
                numbering_profile_code: item.numbering_profile_code
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const app_settings = await db.app_settings.bulkCreate(app_settingsData, { transaction });

        // For each item created, replace relation files
        

        return app_settings;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const app_settings = await db.app_settings.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.accounting_coding_mode !== undefined) updatePayload.accounting_coding_mode = data.accounting_coding_mode;
        
        
        if (data.analytic_levels_count !== undefined) updatePayload.analytic_levels_count = data.analytic_levels_count;
        
        
        if (data.enable_branching !== undefined) updatePayload.enable_branching = data.enable_branching;
        
        
        if (data.enable_multi_currency !== undefined) updatePayload.enable_multi_currency = data.enable_multi_currency;
        
        
        if (data.enable_document_workflow !== undefined) updatePayload.enable_document_workflow = data.enable_document_workflow;
        
        
        if (data.enable_network_dongle !== undefined) updatePayload.enable_network_dongle = data.enable_network_dongle;
        
        
        if (data.default_currency_code !== undefined) updatePayload.default_currency_code = data.default_currency_code;
        
        
        if (data.numbering_profile_code !== undefined) updatePayload.numbering_profile_code = data.numbering_profile_code;
        
        
        updatePayload.updatedById = currentUser.id;

        await app_settings.update(updatePayload, {transaction});

        
        
        if (data.business !== undefined) {
            await app_settings.setBusiness(
              
              data.business,
              
              { transaction }
            );
        }
        

        
        

        

        return app_settings;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const app_settings = await db.app_settings.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of app_settings) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of app_settings) {
                await record.destroy({transaction});
            }
        });


        return app_settings;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const app_settings = await db.app_settings.findByPk(id, options);

        await app_settings.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await app_settings.destroy({
            transaction
        });

        return app_settings;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const app_settings = await db.app_settings.findOne(
            { where },
            { transaction },
        );

        if (!app_settings) {
            return app_settings;
        }

        const output = app_settings.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.business = await app_settings.getBusiness({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.businesses,
        as: 'business',
        
        where: filter.business ? {
          [Op.or]: [
            { id: { [Op.in]: filter.business.split('|').map(term => Utils.uuid(term)) } },
            {
              trade_name: {
                [Op.or]: filter.business.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.default_currency_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_settings',
                        'default_currency_code',
                        filter.default_currency_code,
                    ),
                };
            }
            
            if (filter.numbering_profile_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_settings',
                        'numbering_profile_code',
                        filter.numbering_profile_code,
                    ),
                };
            }
            

            
            

            
            if (filter.analytic_levels_countRange) {
                const [start, end] = filter.analytic_levels_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    analytic_levels_count: {
                    ...where.analytic_levels_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    analytic_levels_count: {
                    ...where.analytic_levels_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.accounting_coding_mode) {
                where = {
                    ...where,
                accounting_coding_mode: filter.accounting_coding_mode,
            };
            }
            
            if (filter.enable_branching) {
                where = {
                    ...where,
                enable_branching: filter.enable_branching,
            };
            }
            
            if (filter.enable_multi_currency) {
                where = {
                    ...where,
                enable_multi_currency: filter.enable_multi_currency,
            };
            }
            
            if (filter.enable_document_workflow) {
                where = {
                    ...where,
                enable_document_workflow: filter.enable_document_workflow,
            };
            }
            
            if (filter.enable_network_dongle) {
                where = {
                    ...where,
                enable_network_dongle: filter.enable_network_dongle,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.app_settings.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'app_settings',
                        'default_currency_code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.app_settings.findAll({
            attributes: [ 'id', 'default_currency_code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['default_currency_code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.default_currency_code,
        }));
    }

    
};

